%define name 	libxine
%define version 0.9.12
%define release 1

%define major 	0
%define libname	%{name}%{major}

Name:        %{name}
Summary:     A portable video/audio library for unix-like systems.
Summary(cs): Penositeln video/audio knihovna pro unixovsk systmy
Summary(de): Eine portabele Audio-/Video-Bibliothek fr Unix-basierende Systeme.
Version:     %{version}
Release:     %{release}
License:     GPL
Group:       Development/Libraries
Source:      http://xine.sourceforge.net/files/xine-lib-0.9.12.tar.gz
URL:         http://xine.sourceforge.net/
Packager:    Daniel Caujolle-Bert <f1rmb@users.sourceforge.net>
BuildPreReq: zlib
BuildRoot:   %{_tmppath}/%{name}-buildroot

%description
%{name} is the beating heart of xine (a free gpl-licensed video player for
unix-like systems) which among others provides support for decoding (and
playing back) of many today available audio/video codecs, like mpeg-4, mpeg-2
and mpeg-1 just to name a few. This library contains (and uses) numerous
processor specific optimizations to provide a smooth playback and to minimize
the overall demand of CPU power.

Don't hesitate to use %{name} in your own projects as long as your usage
complies to the GPL.

%description -l cs
%{name} je tepajc srdce xine (voln iitelnho videopehrvae pod gpl
licenc pro unixovsk systmy). Mimo jin poskytuje podporu pro dekdovn
(a pehrvn) s mnoha dnes dostupnmi audio/video kodeky jako jsou
nap. mpeg-4, mpeg-2 a mpeg-1. Tato knihovna obsahuje a pouv velk poet
procesorov zvislch optimalizac k dosaen plynulho pehrvn a
zmenen celkovho nroku na vkon procesoru.

Dokud to bude ve shod s GPL, nevhejte pout %{name} ve vaich vlastnch
projektech.

%description -l de
%{name} ist das Herzstueck von xine (einem freien, GPL lizensiertem
Audio/Video-Abspielprogramm fr Unix-basierende Systeme). %{name} stellt die
Funktionen zur Dekodierung und Wiedergabe vieler aktueller Audio- und Video-
codecs zur Verfgung, wie z.B. MPEG-4, MPEG-2 und MPEG-1, um nur einige zu
nennen. Die Bibliothek enthaelt und benutzt eine Vielzahl von prozessor-
spezifischen Optimierungen, um eine fluessige Wiedergabe mit minimaler
Prozessorbelastung gewaehrleisten zu koennnen.

Zoegern Sie nicht %{name} in Ihren eigenen Projekten zu nutzen. Beachten Sie
hierzu jedoch die in der GPL Lizenz vereinbarten Bestimmungen.

%package -n %{libname}
Summary:   Required libs to run programs dynamically linked with %{name}.
Summary(cs): Knihovny nutn pro bh program dynamicky linkovanch s %{name}
Summary(de): Benoetigte Bibliotheken, um Programme, die dynamisch gegen %{name} gelinkt sind, benutzen zu koennen.
Group:	   Development/Libraries
Obsoletes: xine, xine-lib, xine-lib-oss, xine-lib-alsa09, xine-lib-arts, xine-lib-esd, xine-lib-dxr3, xine-lib-xv, xine-lib-sdl, xine-lib-aa, xine-lib-opengl, xine-lib-w32dll, xine-lib-oggvorbis
Provides:  %{name} = %{version}-%{release}
Requires:  zlib

%description -n %{libname}
This package is required to run programs dynamically linked with %{name}.

%{name} is the beating heart of xine (a free gpl-licensed video player for
unix-like systems) which among others provides support for decoding (and
playing back) of many today available audio/video codecs, like mpeg-4, mpeg-2
and mpeg-1 just to name a few. This library contains (and uses) numerous
processor specific optimizations to provide a smooth playback and to minimize
the overall demand of CPU power.

Don't hesitate to use %{name} in your own projects as long as your usage
complies to the GPL.

%description -n %{libname} -l cs
Tento balek je nutn pro bh program dynamicky linkovanch s %{name}.

%{name} je tepajc srdce xine (voln iitelnho videopehrvae pod gpl
licenc pro unixovsk systmy). Mimo jin poskytuje podporu pro dekdovn
(a pehrvn) s mnoha dnes dostupnmi audio/video kodeky jako jsou
nap. mpeg-4, mpeg-2 a mpeg-1. Tato knihovna obsahuje a pouv velk poet
procesorov zvislch optimalizac k dosaen plynulho pehrvn a
zmenen celkovho nroku na vkon procesoru.

Dokud to bude ve shod s GPL, nevhejte pout %{name} ve vaich vlastnch
projektech.

%description -n %{libname} -l de
Dieses Paket wird benoetigt, um Programme, die dynamisch gegen %{name}
gelinkt sind, benutzen zu koennen.

%{name} ist das Herzstueck von xine (einem freien, GPL lizensiertem
Audio/Video-Abspielprogramm fr Unix-basierende Systeme). %{name} stellt die
Funktionen zur Dekodierung und Wiedergabe vieler aktueller Audio- und Video-
codecs zur Verfgung, wie z.B. MPEG-4, MPEG-2 und MPEG-1, um nur einige zu
nennen. Die Bibliothek enthaelt und benutzt eine Vielzahl von prozessor-
spezifischen Optimierungen, um eine fluessige Wiedergabe mit minimaler
Prozessorbelastung gewaehrleisten zu koennnen.

Zoegern Sie nicht %{name} in Ihren eigenen Projekten zu nutzen. Beachten Sie
hierzu jedoch die in der GPL Lizenz vereinbarten Bestimmungen.

%package -n %{libname}-devel
Summary:   Header files and documentation to develope programs with %{name}.
Summary(cs): Hlavikov soubory a dokumentace pro vvoj program pouvajcch %{name}.
Summary(de): Headerdateien und Dokumentationen, um Programme mit %{name} entwickeln zu koennen.
Group:	   Development/Libraries
Obsoletes: xine-lib-devel
Provides:  %{name}-devel = %{version}-%{release}
Requires:  %{libname} = %{version}-%{release}

%description -n %{libname}-devel
This package contains header files and documentation required to develope
programs with %{name}.

%{name} is the beating heart of xine (a free gpl-licensed video player for
unix-like systems) which among others provides support for decoding (and
playing back) of many today available audio/video codecs, like mpeg-4, mpeg-2
and mpeg-1 just to name a few. This library contains (and uses) numerous
processor specific optimizations to provide a smooth playback and to minimize
the overall demand of CPU power.

Don't hesitate to use %{name} in your own projects as long as your usage
complies to the GPL.

%description -n %{libname}-devel -l cs
Tento balek obsahuje hlavikov soubory a dokumentaci potebnou pro vvoj
program pouvajcch %{name}.

%{name} je tepajc srdce xine (voln iitelnho videopehrvae pod gpl
licenc pro unixovsk systmy). Mimo jin poskytuje podporu pro dekdovn
(a pehrvn) s mnoha dnes dostupnmi audio/video kodeky jako jsou
nap. mpeg-4, mpeg-2 a mpeg-1. Tato knihovna obsahuje a pouv velk poet
procesorov zvislch optimalizac k dosaen plynulho pehrvn a
zmenen celkovho nroku na vkon procesoru.

Dokud to bude ve shod s GPL, nevhejte pout %{name} ve vaich vlastnch
projektech.

%description -n %{libname}-devel -l de
Dieses Paket enthaelt die Headerdateien und Dokumentationen, um Programme
mit %{name} entwickeln zu koennen.

%{name} ist das Herzstueck von xine (einem freien, GPL lizensiertem
Audio/Video-Abspielprogramm fr Unix-basierende Systeme). %{name} stellt die
Funktionen zur Dekodierung und Wiedergabe vieler aktueller Audio- und Video-
codecs zur Verfgung, wie z.B. MPEG-4, MPEG-2 und MPEG-1, um nur einige zu
nennen. Die Bibliothek enthaelt und benutzt eine Vielzahl von prozessor-
spezifischen Optimierungen, um eine fluessige Wiedergabe mit minimaler
Prozessorbelastung gewaehrleisten zu koennnen.

Zoegern Sie nicht %{name} in Ihren eigenen Projekten zu nutzen. Beachten Sie
hierzu jedoch die in der GPL Lizenz vereinbarten Bestimmungen.

%prep
%setup -q -n xine-lib-0.9.12

%build
if [ ! -f configure ]; then
   NO_CONFIGURE=1 ./cvscompile.sh
fi

#
# currently we do not use %%configure as it seems to cause trouble with
# certain automake produced configure scripts - depending on automake version.
# Use BUILD_ARGS envvar to pass extra parameters to configure (like --enable-dha-mod/etc...)
#
./configure --build=%{_target_platform} --prefix=%{_prefix} \
	    --exec-prefix=%{_exec_prefix} --bindir=%{_bindir} \
	    --sbindir=%{_sbindir} --sysconfdir=%{_sysconfdir} \
	    --datadir=%{_datadir} --includedir=%{_includedir} \
	    --libdir=%{_libdir} --libexecdir=%{_libexecdir} \
	    --localstatedir=%{_localstatedir} \
	    --sharedstatedir=%{_sharedstatedir} --mandir=%{_mandir} \
	    --infodir=%{_infodir} $BUILD_ARGS
make

%install
rm -rf $RPM_BUILD_ROOT
make DESTDIR=%{?buildroot:%{buildroot}} LIBRARY_PATH=%{?buildroot:%{buildroot}}%{_libdir} install

%clean
rm -rf $RPM_BUILD_ROOT

%post -n %{libname} -p /sbin/ldconfig
%postun -n %{libname} -p /sbin/ldconfig

%files -n %{libname}
%defattr(-,root,root)
%doc README TODO AUTHORS COPYING ChangeLog
%{_bindir}/xine-config
%{_libdir}/libxine*.so.*
%{_libdir}/xine/plugins/*
%{_datadir}/xine/skins/*
%{_datadir}/xine/fonts/*
%{_mandir}/man1/*
%{_datadir}/locale/*

%files -n %{libname}-devel
%defattr(-,root,root)
%doc doc/xine-lib-API/html/*.html doc/xine-lib-API/html/*.css
%doc doc/xine-lib-API/html/*.gif doc/xine-lib-API/html/*.png
%doc doc/hackersguide/*.sgml doc/hackersguide/*.fig doc/hackersguide/README
%{_libdir}/libxine*.so
%{_libdir}/libxine*.la
%{_includedir}/xine.h
%{_includedir}/xine/*.h
%{_datadir}/aclocal/xine.m4
%{_mandir}/man3/*

%changelog
* Thu Jun 06 2002 Daniel Caujolle-Bert <f1rmb@users.sourceforge.net>
- ability to pass args to configure. Fix vidix/dhahelper inclusion.
* Mon May 27 2002 Matthias Dahl <matthew2k@web.de>
- added passing of build parameter to configure
* Sun May 26 2002 Matthias Dahl <matthew2k@web.de>
- added german translations by Manfred Tremmel <Manfred.Tremmel@iiv.de>
- added fixes (missing -l cs) by Manfred Tremmel <Manfred.Tremmel@iiv.de>
* Sat May 18 2002 Matthias Dahl <matthew2k@web.de>
- added czech translations by valtri@atlas.cz
* Thu May 16 2002 Matthias Dahl <matthew2k@web.de>
- replaced %configure because it was causing trouble on certain configurations
* Sat May 11 2002 Matthias Dahl <matthew2k@web.de>
- reworked/revamped spec file, still needs some tuning (BuildPreReq, ...)
* Thu May 2 2002 Daniel Caujolle-Bert <f1rmb@users.sourceforge.net>
- sync with new logo stuff.
* Wed May 1 2002 Matthias Dahl <matthew2k@web.de>
- added cinepak, cyuv and msvc decode plugins
- commented out sdl related parts because this is currently broken in xine-lib
- added 'cs,pl_PL' translation catalogs
* Sun Mar 31 2002 Matthias Dahl <matthew2k@web.de>
- added mms input plugin, spucc decoder and missing xine_logo.zyuy2.
- commented out video fill decoder for now as it seems to be no longer built
* Wed Feb 6 2002 Daniel Caujolle-Bert <f1rmb@users.sourceforge.net>
- added 'de,fr,pt_BR' translation catalogs.
* Sat Dec 26 2001 Matthias Dahl <matthew2k@web.de>
- added sputext decode plugin and fonts.
* Sat Dec 8 2001 Daniel Caujolle-Bert <f1rmb@users.sourceforge.net>
- ASF plugin is optional.
* Thu Dec 6 2001 Daniel Caujolle-Bert <f1rmb@users.sourceforge.net>
- Add cda plugins.
* Wed Nov 14 2001 Daniel Caujolle-Bert <f1rmb@users.sourceforge.net>
- fixed dxr3 header files inclusion, aalib deps: thanks to Andrew Meredith <andrew@anvil.org>.
* Mon Oct 29 2001 Matthias Dahl <matthew2k@web.de>
- added http input plugin
* Thu Oct 18 2001 Matthias Dahl <matthew2k@web.de>
- added asf demuxer plugin
* Sun Oct 14 2001 Daniel Caujolle-Bert <f1rmb@users.sourceforge.net>
- move vorbis in separate package. Add DivX4 decoder plugin.
* Wed Oct 10 2001 Matthias Dahl <matthew2k@web.de>
- added vorbis files and missing man pages to filelist.
* Thu Sep 27 2001 Daniel Caujolle-Bert <f1rmb@users.sourceforge.net>
- Add desktop stuff from patches by Miguel Freitas <miguel@cetuc.puc-rio.br>
- Fixed xine.m4 installation from Andrew Meredith <andrew@anvil.org>
* Fri Sep 21 2001 Matthias Dahl <matthew2k@web.de>
- added two missing files (xine-config man page and xine.m4)
* Sun Sep 16 2001 Daniel Caujolle-Bert <f1rmb@users.sourceforge.net>
- Merge patch from Jos Carlos Monteiro <jcm@netcabo.pt>:
  - Filelist and other minor updates,
  - Fixed some SuSE compatibility issues,
  - Added Portuguese summary.
* Sun Sep 16 2001 Daniel Caujolle-Bert <f1rmb@users.sourceforge.net>
- Add missing files.
* Sun Aug 19 2001 Matthias Dahl <matthew2k@web.de>
- The usual update to the filelist :)
- temporarily removed mpg123 decoder plugin from filelist cause it is not
  built with the recent CVS tree
* Thu Jul 26 2001 Daniel Caujolle-Bert <f1rmb@users.sourceforge.net>
- Made oss, aa, xv, esd, w32dll, documentation as separate packages.
* Thu Jul 26 2001 Matthias Dahl <matthew2k@web.de>
- added seperate arts package and one missing demuxer plugin to filelist
* Wed Jul 18 2001 Daniel Caujolle-Bert <f1rmb@users.sourceforge.net>
- list all plugins to avoid *strange* inclusion ;-).
* Sun Jun 10 2001 Matthias Dahl <matthew2k@web.de>
- updated filelist
- re-activated execution of /sbin/ldconfig as post install script
* Thu Mar 28 2001 Daniel Caujolle-Bert <f1rmb@users.sourceforge.net>
- add korean summary, patch from Louis JANG <louis@ns.mizi.com>
* Thu Jan 11 2001 Daniel Caujolle-Bert <f1rmb@users.sourceforge.net>
- patch from Sung-Hyun Nam <namsh@lgic.co.kr> applied.
* Fri Oct 17 2000 Daniel Caujolle-Bert <f1rmb@users.sourceforge.net>
- first spec file.
